/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.HispropriedadesRecord;

import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Hispropriedades extends TableImpl<HispropriedadesRecord> {

    private static final long serialVersionUID = 79004130;

    /**
     * The reference instance of <code>public.hispropriedades</code>
     */
    public static final Hispropriedades HISPROPRIEDADES = new Hispropriedades();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<HispropriedadesRecord> getRecordType() {
        return HispropriedadesRecord.class;
    }

    /**
     * The column <code>public.hispropriedades.hispoptid</code>.
     */
    public final TableField<HispropriedadesRecord, Integer> HISPOPTID = createField("hispoptid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('hispropriedades_hispoptid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.hispropriedades.fkardid</code>.
     */
    public final TableField<HispropriedadesRecord, Integer> FKARDID = createField("fkardid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hispropriedades.fktanid</code>.
     */
    public final TableField<HispropriedadesRecord, Integer> FKTANID = createField("fktanid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hispropriedades.fksenid</code>.
     */
    public final TableField<HispropriedadesRecord, Integer> FKSENID = createField("fksenid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hispropriedades.fkempid</code>.
     */
    public final TableField<HispropriedadesRecord, Integer> FKEMPID = createField("fkempid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hispropriedades.hora</code>.
     */
    public final TableField<HispropriedadesRecord, String> HORA = createField("hora", org.jooq.impl.SQLDataType.VARCHAR(50).defaultValue(org.jooq.impl.DSL.field("CURRENT_TIME", org.jooq.impl.SQLDataType.VARCHAR)), this, "");

    /**
     * The column <code>public.hispropriedades.dia</code>.
     */
    public final TableField<HispropriedadesRecord, Date> DIA = createField("dia", org.jooq.impl.SQLDataType.DATE.defaultValue(org.jooq.impl.DSL.field("CURRENT_DATE", org.jooq.impl.SQLDataType.DATE)), this, "");

    /**
     * The column <code>public.hispropriedades.medida</code>.
     */
    public final TableField<HispropriedadesRecord, String> MEDIDA = createField("medida", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * Create a <code>public.hispropriedades</code> table reference
     */
    public Hispropriedades() {
        this(DSL.name("hispropriedades"), null);
    }

    /**
     * Create an aliased <code>public.hispropriedades</code> table reference
     */
    public Hispropriedades(String alias) {
        this(DSL.name(alias), HISPROPRIEDADES);
    }

    /**
     * Create an aliased <code>public.hispropriedades</code> table reference
     */
    public Hispropriedades(Name alias) {
        this(alias, HISPROPRIEDADES);
    }

    private Hispropriedades(Name alias, Table<HispropriedadesRecord> aliased) {
        this(alias, aliased, null);
    }

    private Hispropriedades(Name alias, Table<HispropriedadesRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.HISPROPRIEDADES_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<HispropriedadesRecord, Integer> getIdentity() {
        return Keys.IDENTITY_HISPROPRIEDADES;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<HispropriedadesRecord> getPrimaryKey() {
        return Keys.HISPROPRIEDADES_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<HispropriedadesRecord>> getKeys() {
        return Arrays.<UniqueKey<HispropriedadesRecord>>asList(Keys.HISPROPRIEDADES_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<HispropriedadesRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<HispropriedadesRecord, ?>>asList(Keys.HISPROPRIEDADES__HISPROPRIEDADES_FKARDID_FKEY, Keys.HISPROPRIEDADES__HISPROPRIEDADES_FKTANID_FKEY, Keys.HISPROPRIEDADES__HISPROPRIEDADES_FKSENID_FKEY, Keys.HISPROPRIEDADES__HISPROPRIEDADES_FKEMPID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Hispropriedades as(String alias) {
        return new Hispropriedades(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Hispropriedades as(Name alias) {
        return new Hispropriedades(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Hispropriedades rename(String name) {
        return new Hispropriedades(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Hispropriedades rename(Name name) {
        return new Hispropriedades(name, null);
    }
}
